#include <stdio.h>

#define MAX_NAME_LEN 256

int askuser(char *prompt);
void usage();

int main(int argc, char *argv[]) {
   FILE *zzt_prog;
   char filename[MAX_NAME_LEN];
   unsigned char comp_chk;

   if(argc <= 1) {
      filename[0] = '\0';
   }
   else if((!strcmp(argv[1], "/?")) || (!strcmp(argv[1], "-h")) ||
     (!strcmp(argv[1], "-H"))) {
      usage();
      return 0;
   }
   else if(strlen(argv[1]) > (MAX_NAME_LEN-8)) {
      fprintf(stderr, "Your path is too long.\n");
      return -1;
   }
   else {
      strcpy(filename, argv[1]);
      strcat(filename, "\\");
   }
   strcat(filename, "ZZT.EXE");

   zzt_prog = fopen(filename, "r+wb");

   if(zzt_prog == NULL) {
      fprintf(stderr, "Could not open 'ZZT.EXE'.\n");
      return -1;
   }

   fseek(zzt_prog, 2, SEEK_SET);
   fscanf(zzt_prog, "%c", &comp_chk);

   if(comp_chk == 0x94) {
      fprintf(stderr, "Please uncompress 'ZZT.EXE' with UNLZEXE first.\n");
      fclose(zzt_prog);
      return -1;
   }

   fseek(zzt_prog, 7533, SEEK_SET);
   fprintf(zzt_prog, "%c%c%c%c%c%c%c%c%c", 'P', 'a', 't', 'c', 'h', 'e',
     'd', ' ', 'v');

   fseek(zzt_prog, 22421, SEEK_SET);
   if(askuser("Disable \"Ammunition - 5 shots...\" message? ")) {
      fprintf(zzt_prog, "%c", 0x00);
   }
   else {
      fprintf(zzt_prog, "%c", 0x23);
   }

   fseek(zzt_prog, 22560, SEEK_SET);
   if(askuser("Disable \"Gems give you Health!\" message? ")) {
      fprintf(zzt_prog, "%c", 0x00);
   }
   else {
      fprintf(zzt_prog, "%c", 0x15);
   }

   fseek(zzt_prog, 23729, SEEK_SET);
   if(askuser("Disable \"Torch - used for...\" message? ")) {
      fprintf(zzt_prog, "%c", 0x00);
   }
   else {
      fprintf(zzt_prog, "%c", 0x2D);
   }

   fseek(zzt_prog, 24026, SEEK_SET);
   if(askuser("Disable \"A path is cleared...\" message? ")) {
      fprintf(zzt_prog, "%c", 0x00);
   }
   else {
      fprintf(zzt_prog, "%c", 0x25);
   }

   fseek(zzt_prog, 24155, SEEK_SET);
   if(askuser("Disable \"A fake wall...\" message? ")) {
      fprintf(zzt_prog, "%c", 0x00);
   }
   else {
      fprintf(zzt_prog, "%c", 0x1D);
   }

   fseek(zzt_prog, 24597, SEEK_SET);
   if(askuser("Disable \"Your way is blocked by water.\" message? ")) {
      fprintf(zzt_prog, "%c", 0x00);
   }
   else {
      fprintf(zzt_prog, "%c", 0x1D);
   }

   fseek(zzt_prog, 66859, SEEK_SET);
   if(askuser("Disable \"Room is dark - you need...\" message? ")) {
      fprintf(zzt_prog, "%c", 0x00);
   }
   else {
      fprintf(zzt_prog, "%c", 0x29);
   }

   fclose(zzt_prog);

   return 0;
}


int askuser(char *prompt) {
   char reply;

   fprintf(stdout, prompt);
   fflush(stdout);
   fscanf(stdin, "%c", &reply);
   fflush(stdin);

   if(reply == 'y' || reply == 'Y') {
      return 1;
   }
   else {
      return 0;
   }
}

void usage() {
   fprintf(stdout, "Usage:     ZZTPATCH.EXE [/? \| pathname]\n");
   fprintf(stdout, "Arguments: /? - Displays this screen\n");
   fprintf(stdout, "           pathname - The path in which ZZT.EXE"
		   " is located\n");
   fprintf(stdout, "Purpose:   ZZTPATCH.EXE is a program that allows you\n"
		   "           to disable certain messages that ZZT\n"
		   "           displays.  Many people find such messages\n"
		   "           annoying.\n");
   fprintf(stdout, "\nSee README.DOC for more information.\n");
   fprintf(stdout, "ZZTPatch 1.0, Copyright (C) 1999 by Grant Watson\n");
   return;
}